VERSION 5.00
Begin VB.Form frmLauncher 
   BorderStyle     =   1  'Fixed Single
   ClientHeight    =   3090
   ClientLeft      =   150
   ClientTop       =   435
   ClientWidth     =   5775
   Icon            =   "frmLauncher.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3090
   ScaleWidth      =   5775
   StartUpPosition =   3  'Windows Default
   Begin VB.CheckBox chkDebug 
      Caption         =   "&Debug/Cheat keys"
      Height          =   255
      Left            =   3120
      TabIndex        =   6
      Top             =   1800
      Width           =   1935
   End
   Begin VB.CheckBox chkSkipPolice 
      Caption         =   "&Skip Police"
      Height          =   255
      Left            =   3120
      TabIndex        =   5
      Top             =   1440
      Width           =   1815
   End
   Begin VB.CheckBox chkLives 
      Caption         =   "&Infinite Lives"
      Height          =   255
      Left            =   3120
      TabIndex        =   3
      Top             =   720
      Width           =   1455
   End
   Begin VB.ListBox lstMaps 
      Height          =   2400
      ItemData        =   "frmLauncher.frx":08CA
      Left            =   120
      List            =   "frmLauncher.frx":08CC
      TabIndex        =   0
      Top             =   0
      Width           =   2895
   End
   Begin VB.CheckBox chkKeepWeapons 
      Caption         =   "&Keep Weapons After Death"
      Height          =   255
      Left            =   3120
      TabIndex        =   2
      Top             =   360
      Width           =   2775
   End
   Begin VB.CheckBox chkInvul 
      Caption         =   "I&nvulnerability*"
      Height          =   255
      Left            =   3120
      TabIndex        =   4
      Top             =   1080
      Width           =   1575
   End
   Begin VB.CheckBox chkGetAllWeapons 
      Caption         =   "&Get All Weapons"
      Height          =   255
      Left            =   3120
      TabIndex        =   1
      Top             =   0
      Width           =   2055
   End
   Begin VB.CommandButton cmdStart 
      Caption         =   "&Launch GTA2"
      Default         =   -1  'True
      Height          =   495
      Left            =   120
      TabIndex        =   7
      Top             =   2520
      Width           =   1215
   End
End
Attribute VB_Name = "frmLauncher"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim strGMP As String
Dim strSTY As String
Dim strSCR As String
Dim strClassKey
Dim cR As New cRegistry
Dim i As Integer
Dim strMaps(11, 3) As String
Const vbTitle = "Sektor's GTA2 Launcher v0.4"

Private Sub cmdStart_Click()
    
    If Val(DetectGTA2version) < 11 Then
        strClassKey = HKEY_LOCAL_MACHINE
    Else
        strClassKey = HKEY_CURRENT_USER
    End If
    
    With cR
        .ClassKey = strClassKey
        .SectionKey = "software\DMA Design Ltd\GTA2\Screen"
        .ValueType = REG_SZ
        .ValueKey = "min_frame_rate"
        .Value = 1
    End With
    
    'Save the selected map index to the registry
    With cR
        .ClassKey = strClassKey
        .SectionKey = "software\GTA2 Game Hunter"
        .ValueType = REG_SZ
        .ValueKey = "map_index"
        .Value = i
    End With
    
    strGMP = strMaps(lstMaps.ListIndex, 1)
    strSTY = strMaps(lstMaps.ListIndex, 2)
    strSCR = strMaps(lstMaps.ListIndex, 3)
    
    'Write the data from the selected MMP to the registry, so GTA2 can read it
    With cR
        .ClassKey = strClassKey
        .SectionKey = "software\dma design ltd\gta2\Debug\"
        .ValueType = REG_SZ
        .ValueKey = "mapname"
        .Value = strGMP
        .ValueKey = "scriptName"
        .Value = strSCR
        .ValueKey = "stylename"
        .Value = strSTY
        .ValueType = REG_DWORD
        .ValueKey = "skip_frontend"
        .Value = 0
        .ValueKey = "do_blood"
        .Value = 0
        
        .ValueKey = "do_infinite_lives"
        If chkLives Then
            .Value = 0
        Else
            .DeleteValue
        End If
        
        .ValueKey = "get_all_weapons"
        If chkGetAllWeapons Then
            .Value = 0
        Else
            .DeleteValue
        End If
        
        .ValueKey = "keep_weapons_after_death"
        If chkKeepWeapons Then
            .Value = 0
        Else
            .DeleteValue
        End If
        
        .ValueKey = "do_invulnerable"
        If chkInvul Then
            .Value = 0
        Else
            .DeleteValue
        End If
        
        .ValueKey = "skip_police"
        If chkSkipPolice Then
            .Value = 0
        Else
            .DeleteValue
        End If
        
        .ValueKey = "do_debug_keys"
        If chkDebug Then
            .Value = 0
        Else
            .DeleteValue
        End If
        
    End With
        
    'Launch GTA2
    If Right$(strGTA2path, 1) <> "\" Then strGTA2path = strGTA2path & "\"
    If exists(strGTA2path & "gta2.exe") Then
        ChDrive Left$(strGTA2path, 1)
        ChDir strGTA2path
        Shell strGTA2path & "gta2.exe", vbNormalFocus
    Else
        MsgBox strGTA2path & "gta2.exe not found!"
    End If
    
    Exit Sub
oops:
    strErrdesc = Err.Description
    strErrLine = Erl
    MsgBox "Error: " & strErrdesc & " - Line: " & strErrLine
End Sub

Private Sub Form_Load()
    On Error GoTo oops
    
    If DetectGTA2version > "11" Then
        strClassKey = HKEY_CURRENT_USER
    Else
        strClassKey = HKEY_LOCAL_MACHINE
    End If
    
    With cR
        .ClassKey = HKEY_CURRENT_USER
        .SectionKey = "SOFTWARE\GTA2 Game Hunter"
        .ValueKey = "GTA2Folder"
        strGTA2path = .Value
    End With
    
    If exists(strGTA2path & "data\attract\attr1.rep") = False Then browse
    
    Call readMaps
    
    Exit Sub
oops:
    strErrdesc = Err.Description
    strErrLine = Erl
    MsgBox "Error: " & strErrdesc & " Line: " & Erl
End Sub

Private Sub readMaps()

lstMaps.AddItem "1st City - Downtown"
lstMaps.AddItem "2nd City - Residential"
lstMaps.AddItem "3rd City - Industrial"
lstMaps.AddItem "1st City Bonus 1"
lstMaps.AddItem "1st City Bonus 2"
lstMaps.AddItem "1st City Bonus 3"
lstMaps.AddItem "2nd City Bonus 1"
lstMaps.AddItem "2nd City Bonus 2"
lstMaps.AddItem "2nd City Bonus 3"
lstMaps.AddItem "3rd City Bonus 1"
lstMaps.AddItem "3rd City Bonus 2"
lstMaps.AddItem "3rd City Bonus 3"

lstMaps.Selected(0) = True

With cR
    .ClassKey = strClassKey
    .SectionKey = "software\dma design ltd\gta2\Debug\"
    .ValueKey = "do_infinite_lives"
    If .Value <> vbNullString Then chkLives = vbChecked

    .ValueKey = "get_all_weapons"
    If .Value <> vbNullString Then chkGetAllWeapons = vbChecked
    
    .ValueKey = "keep_weapons_after_death"
    If .Value <> vbNullString Then chkKeepWeapons = vbChecked
    
    .ValueKey = "do_invulnerable"
    If .Value <> vbNullString Then chkInvul.Value = vbChecked
    
    .ValueKey = "skip_police"
    If .Value <> vbNullString Then chkSkipPolice.Value = vbChecked
    
    .ValueKey = "do_debug_keys"
    If .Value <> vbNullString Then chkDebug.Value = vbChecked
End With

strMaps(0, 0) = "1st City - Downtown"
strMaps(0, 1) = "wil.gmp"
strMaps(0, 2) = "wil.sty"
strMaps(0, 3) = "wil.scr"

strMaps(1, 0) = "2nd City - Residential"
strMaps(1, 1) = "ste.gmp"
strMaps(1, 2) = "ste.sty"
strMaps(1, 3) = "ste.scr"

strMaps(2, 0) = "3rd City - Industrial"
strMaps(2, 1) = "bil.gmp"
strMaps(2, 2) = "bil.sty"
strMaps(2, 3) = "bil.scr"

strMaps(3, 0) = "1st City Bonus 1"
strMaps(3, 1) = "lorne2e.gmp"
strMaps(3, 2) = "wil.sty"
strMaps(3, 3) = "lorne2e.scr"

strMaps(4, 0) = "1st City Bonus 2"
strMaps(4, 1) = "lorne2m.gmp"
strMaps(4, 2) = "wil.sty"
strMaps(4, 3) = "lorne2m.scr"

strMaps(5, 0) = "1st City Bonus 3"
strMaps(5, 1) = "lorne2h.gmp"
strMaps(5, 2) = "wil.sty"
strMaps(5, 3) = "lorne2h.scr"

strMaps(6, 0) = "2nd City Bonus 1"
strMaps(6, 1) = "mike1e.gmp"
strMaps(6, 2) = "ste.sty"
strMaps(6, 3) = "mike1e.scr"

strMaps(7, 0) = "2nd City Bonus 2"
strMaps(7, 1) = "mike1m.gmp"
strMaps(7, 2) = "ste.sty"
strMaps(7, 3) = "mike1m.scr"

strMaps(8, 0) = "2nd City Bonus 3"
strMaps(8, 1) = "mike1h.gmp"
strMaps(8, 2) = "ste.sty"
strMaps(8, 3) = "mike1h.scr"

strMaps(9, 0) = "3rd City Bonus 1"
strMaps(9, 1) = "mike2e.gmp"
strMaps(9, 2) = "bil.sty"
strMaps(9, 3) = "mike2e.scr"

strMaps(10, 0) = "3rd City Bonus 2"
strMaps(10, 1) = "mike2m.gmp"
strMaps(10, 2) = "bil.sty"
strMaps(10, 3) = "mike2m.scr"

strMaps(11, 0) = "3rd City Bonus 3"
strMaps(11, 1) = "mike2h.gmp"
strMaps(11, 2) = "bil.sty"
strMaps(11, 3) = "mike2h.scr"

'
'    With lvMaps.ListItems.Add(, , "1st City - Downtown")
'        .ListSubItems.Add , , ""
'        .ListSubItems.Add , , "wil.gmp"
'        .ListSubItems.Add , , "wil.sty"
'        .ListSubItems.Add , , "wil.scr"
'    End With
'
'    With lvMaps.ListItems.Add(, , "2nd City - Residential")
'        .ListSubItems.Add , , ""
'        .ListSubItems.Add , , "ste.gmp"
'        .ListSubItems.Add , , "ste.sty"
'        .ListSubItems.Add , , "ste.scr"
'    End With
'
'    With lvMaps.ListItems.Add(, , "3rd City - Industrial")
'        .ListSubItems.Add , , ""
'        .ListSubItems.Add , , "bil.gmp"
'        .ListSubItems.Add , , "bil.sty"
'        .ListSubItems.Add , , "bil.scr"
'    End With
'
'    With lvMaps.ListItems.Add(, , "1st City Bonus 1")
'        .ListSubItems.Add , , ""
'        .ListSubItems.Add , , "lorne2e.gmp"
'        .ListSubItems.Add , , "wil.sty"
'        .ListSubItems.Add , , "lorne2e.scr"
'    End With
'
'    With lvMaps.ListItems.Add(, , "1st City Bonus 2")
'        .ListSubItems.Add , , ""
'        .ListSubItems.Add , , "lorne2m.gmp"
'        .ListSubItems.Add , , "wil.sty"
'        .ListSubItems.Add , , "lorne2m.scr"
'    End With
'
'    With lvMaps.ListItems.Add(, , "1st City Bonus 3")
'        .ListSubItems.Add , , ""
'        .ListSubItems.Add , , "lorne2h.gmp"
'        .ListSubItems.Add , , "wil.sty"
'        .ListSubItems.Add , , "lorne2h.scr"
'    End With
'
'    With lvMaps.ListItems.Add(, , "2nd City Bonus 1")
'        .ListSubItems.Add , , ""
'        .ListSubItems.Add , , "mike1e.gmp"
'        .ListSubItems.Add , , "ste.sty"
'        .ListSubItems.Add , , "mike1e.scr"
'    End With
'
'    With lvMaps.ListItems.Add(, , "2nd City Bonus 2")
'        .ListSubItems.Add , , ""
'        .ListSubItems.Add , , "mike1m.gmp"
'        .ListSubItems.Add , , "ste.sty"
'        .ListSubItems.Add , , "mike1m.scr"
'    End With
'
'    With lvMaps.ListItems.Add(, , "2nd City Bonus 3")
'        .ListSubItems.Add , , ""
'        .ListSubItems.Add , , "mike1h.gmp"
'        .ListSubItems.Add , , "ste.sty"
'        .ListSubItems.Add , , "mike1h.scr"
'    End With
'
'    With lvMaps.ListItems.Add(, , "3rd City Bonus 1")
'        .ListSubItems.Add , , ""
'        .ListSubItems.Add , , "mike2e.gmp"
'        .ListSubItems.Add , , "bil.sty"
'        .ListSubItems.Add , , "mike2e.scr"
'    End With
'
'    With lvMaps.ListItems.Add(, , "3rd City Bonus 2")
'        .ListSubItems.Add , , ""
'        .ListSubItems.Add , , "mike2m.gmp"
'        .ListSubItems.Add , , "bil.sty"
'        .ListSubItems.Add , , "mike2m.scr"
'    End With
'
'    With lvMaps.ListItems.Add(, , "3rd City Bonus 3")
'        .ListSubItems.Add , , ""
'        .ListSubItems.Add , , "mike2h.gmp"
'        .ListSubItems.Add , , "bil.sty"
'        .ListSubItems.Add , , "mike2h.scr"
'    End With
    
    Me.Caption = vbTitle
    
End Sub

Private Sub Form_unload(Cancel As Integer)
    With cR
        .ClassKey = strClassKey 'GTA2 v10.5 and older
        .SectionKey = "software\dma design ltd\gta2\Debug\"
        .ValueKey = "skip_frontend"
        .DeleteValue
        
        .ClassKey = strClassKey 'GTA2 v11.0
        .SectionKey = "software\dma design ltd\gta2\Debug\"
        .ValueKey = "skip_frontend"
        .DeleteValue
    End With
End Sub
